searchNodes=[{"doc":"Use LEDs for your user interface delux simplifies creating and running LED blink patterns for use as part of a user interface for an embedded hardware. This library provides: Low overhead LED control via Linux's Sysclass interface - blink sequences get compiled down so that they can be run inside the Linux kernel. Built-in LED effects for common use cases like blinking, cycling LED colors, etc. Prioritization of LED effects Support for many physical LED configurations Nice textual descriptions of what the LED is doing to support remote debug This library is primarily intended for devices with 1 to 10 LEDs. It's currently not for Neopixels and other &quot;smart&quot; LEDs that are more typically found in larger numbers, but could be used for a similar purpose. Before diving in, some terminology is needed: LED - one light emitting element. This doesn't have to be an LED, but the Linux kernel must think that it is and show a directory for it under /sys/class/leds/ . Indicator - a group of 1, 2, or 3 LEDs that a user would perceive as one. This could be a lone green LED, or a red, green and blue LED in one package, or any combination. Program - a one-time or repeating set of instructions for controlling an indicator. Pattern - a low-level sequence of brightness and duration tuples for controlling one LED Slot - a holder for a program. Slots are ordered so a program put in a higher priority slot will take precedence over one in a lower priority slot. For example, if there's a UI feedback slot and a network status slot, programs running in the UI feedback slot could take precedence. To give a flavor of how delux works, here's an example that configures delux with one green LED and then blinks it at 2 Hz: iex&gt; Delux . start_link ( indicators : %{ default : %{ green : &quot;led0&quot; } } ) iex&gt; Delux . render ( Delux.Effects . blink ( :green , 2 ) ) iex&gt; Delux . info ( ) green at 2 Hz This starts Delux with one indicator, :default , that has a green LED known to Linux as &quot;led0&quot; . The Delux.Effects.blink/2 function creates a 2 Hz blinking program for Delux to render. With nothing else specified, Delux.render/1 runs the program on the default indicator in the default slot.","ref":"Delux.html","title":"Delux","type":"module"},{"doc":"Adjust the overall brightness of all indicators Effects are adjusted based on the value passed. NOTE: This is not fully supported yet!","ref":"Delux.html#adjust_brightness/2","title":"Delux.adjust_brightness/2","type":"function"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Delux.html#child_spec/1","title":"Delux.child_spec/1","type":"function"},{"doc":"Clear out all programs in the specified slot The indicator is turned off if there are no programs in any slot.","ref":"Delux.html#clear/2","title":"Delux.clear/2","type":"function"},{"doc":"Call info/2 with the defaults","ref":"Delux.html#info/0","title":"Delux.info/0","type":"function"},{"doc":"Call info/2 with the specified indicator","ref":"Delux.html#info/1","title":"Delux.info/1","type":"function"},{"doc":"Print out info about an indicator This is handy when you can't physically see an indicator. It's intended for users at the IEx prompt. For programmatic use, see info_as_ansidata/2 .","ref":"Delux.html#info/2","title":"Delux.info/2","type":"function"},{"doc":"Call info_as_ansidata/2 with the defaults","ref":"Delux.html#info_as_ansidata/0","title":"Delux.info_as_ansidata/0","type":"function"},{"doc":"Call info_as_ansidata/2 with the specified indicator","ref":"Delux.html#info_as_ansidata/1","title":"Delux.info_as_ansidata/1","type":"function"},{"doc":"Return user-readable information about an indicator","ref":"Delux.html#info_as_ansidata/2","title":"Delux.info_as_ansidata/2","type":"function"},{"doc":"Helper for rendering a program when using Delux's defaults This calls render/3 using the default Delux GenServer and default slot.","ref":"Delux.html#render/1","title":"Delux.render/1","type":"function"},{"doc":"Helper for rendering a program to a slot This calls render/3 using the default Delux GenServer.","ref":"Delux.html#render/2","title":"Delux.render/2","type":"function"},{"doc":"Update one or more indicators to a new program Passing nil for the program removes the program running in the specified slot. This is the same as calling clear/2 .","ref":"Delux.html#render/3","title":"Delux.render/3","type":"function"},{"doc":"Start an Delux GenServer See t:options() for configuration options","ref":"Delux.html#start_link/1","title":"Delux.start_link/1","type":"function"},{"doc":"Configuration for an indicator Specify the Linux LED name for each LED. Single LED indicators should use a color that's close or just choose :red .","ref":"Delux.html#t:indicator_config/0","title":"Delux.indicator_config/0","type":"type"},{"doc":"The name for one indicator An indicator may be composed of multiple LEDs, but they're arranged such that it looks like one light source to someone looking at it. For example, an RGB LED has 3 LEDs inside of it. These can be anything you want. If you don't explicitly specify indicator names, an indicator named :default is used.","ref":"Delux.html#t:indicator_name/0","title":"Delux.indicator_name/0","type":"type"},{"doc":"Delux configuration options :indicators - a map of indicator names to their configurations :slots - a list of slot atoms from lowest to highest priority. Defaults to [:status, :notification, :user_feedback] :name - register the Delux GenServer using this name. Defaults to Delux . Specify nil to not register a name. :backend - options for the backend :led_path - the path to the LED directories (defaults to &quot;/sys/class/leds&quot; ) :hz - the Linux kernel's HZ setting. Delux will adjust its timing based on this setting (defaults to 1000)","ref":"Delux.html#t:options/0","title":"Delux.options/0","type":"type"},{"doc":"A name of a slot for an indicator program Slots determine which program is rendered when more than one can be shown at the same time. The default slot is :status which is also the lowest priority slot. The :notification and :user_feedback slots are higher priority. For example, rendering visual feedback to the user pressing a button can be assigned to the :user_feedback slot so the user knows that the button pressed worked regardless of what else is happening.","ref":"Delux.html#t:slot/0","title":"Delux.slot/0","type":"type"},{"doc":"Functions for creating a variety of LED patterns","ref":"Delux.Effects.html","title":"Delux.Effects","type":"module"},{"doc":"Blink an indicator This returns a pattern that blinks the specified color at a 50% duty cycle. The pattern starts on and then goes off.","ref":"Delux.Effects.html#blink/3","title":"Delux.Effects.blink/3","type":"function"},{"doc":"Create a transient two color sequence The first color is shown for 20 ms. 10 ms in, the second color is shown for 20 ms. The Effects is a quick flash of light that can be used to show feedback to a button. Total duration of the Effects is 40 ms.","ref":"Delux.Effects.html#blip/3","title":"Delux.Effects.blip/3","type":"function"},{"doc":"Cycle between colors Colors are shown with equal duration determined from the specified frequency.","ref":"Delux.Effects.html#cycle/3","title":"Delux.Effects.cycle/3","type":"function"},{"doc":"Blink out a number This returns a pattern that blinks out a number. It's good for communicating small numbers to viewers. It repeats. Options: :inter_number_delay - the amount of milliseconds to wait in between blinking out the count (defaults to 2000 ms) :blink_on_duration - how long to keep the LED on when blinking (defaults to 250 ms) :blink_off_duration - how long to keep the LED off when blinking (defaults to 250 ms)","ref":"Delux.Effects.html#number_blink/3","title":"Delux.Effects.number_blink/3","type":"function"},{"doc":"All LEDs off","ref":"Delux.Effects.html#off/0","title":"Delux.Effects.off/0","type":"function"},{"doc":"Set an indicator to the specified color","ref":"Delux.Effects.html#on/2","title":"Delux.Effects.on/2","type":"function"},{"doc":"Create a program to verify timing If you're unsure about the playback timing on your device, hook up a logic analyzer to an LED and capture the waveform. Here's what you should see: 100 ms on 10 ms off 1 ms on 10 ms off 2 ms on 10 ms off 3 ms on 10 ms off 5 ms on 10 ms off 8 ms on 10 ms off 13 ms on 10 ms off 100 ms on off Look at the following in the capture: Do the 1, 2, 3, 5 ms captures match what you'd expect based on your kernel's HZ setting. For example, if HZ=100, they should all be 10 ms long. If not, check the :hz setting for Delux. Does the length of the final 100 ms on time match the first. If not, Delux might be calculating the duration wrong and cutting off the program prematurely. This is likely due to an incorrect :hz setting. If something still isn't right, please submit an issue with the captured waveform and any other hints you may have to reproduce.","ref":"Delux.Effects.html#timing_test/2","title":"Delux.Effects.timing_test/2","type":"function"},{"doc":"Create a program from an arbitrary function Pass in a function that takes times in milliseconds and returns colors. The returned pattern piecewise linearly interpolates the waveform. Here's an example of a 0.5 Hz blue sine wave: Effects . waveform ( fn t -&gt; { 0 , 0 , 0.5 + 0.5 * :math . cos ( :math . pi ( ) * t / 1000 ) } end , 2000 ) When trying this, keep in mind that if the LEDs in the indicator don't support varying levels of brightness, it won't look like a sine wave. Options :time_step - the number of milliseconds between each sample. Defaults to 100 ms.","ref":"Delux.Effects.html#waveform/3","title":"Delux.Effects.waveform/3","type":"function"},{"doc":"Options for all effects (none yet)","ref":"Delux.Effects.html#t:common_options/0","title":"Delux.Effects.common_options/0","type":"type"},{"doc":"Functions for Morse code patterns","ref":"Delux.Morse.html","title":"Delux.Morse","type":"module"},{"doc":"Convert a string to an indicator program Options: :words_per_minute - the rate at which to send the message","ref":"Delux.Morse.html#encode/3","title":"Delux.Morse.encode/3","type":"function"},{"doc":"","ref":"Delux.Morse.html#t:options/0","title":"Delux.Morse.options/0","type":"type"},{"doc":"Utility functions for handling element sequences for one LED","ref":"Delux.Pattern.html","title":"Delux.Pattern","type":"module"},{"doc":"Return a number of ms that should be considered a long time Linux doesn't support an infinite timeout, so use this value instead.","ref":"Delux.Pattern.html#forever_ms/0","title":"Delux.Pattern.forever_ms/0","type":"function"},{"doc":"PWM a sequence of elements The resulting sequence will only be fully on or fully off. See caveats in Program.adjust_brightness_pwm/2 . IMPORTANT: This function is VERY incomplete right now. It requires much more thought to work around flickering issues at low PWM rates.","ref":"Delux.Pattern.html#pwm/2","title":"Delux.Pattern.pwm/2","type":"function"},{"doc":"Reduce the number of transitions in a sequence This reduces the length of the pattern and in some cases makes it use less of the CPU to run. It's useful for programmatically generated patterns that can take inputs that generate lots of repeating sequences.","ref":"Delux.Pattern.html#simplify/1","title":"Delux.Pattern.simplify/1","type":"function"},{"doc":"Value, duration for one component Values are 0 to 1 and durations are in milliseconds.","ref":"Delux.Pattern.html#t:element/0","title":"Delux.Pattern.element/0","type":"type"},{"doc":"Integer durations in milliseconds","ref":"Delux.Pattern.html#t:milliseconds/0","title":"Delux.Pattern.milliseconds/0","type":"type"},{"doc":"A sequence of elements These get processed into the pattern string that's sent to Linux.","ref":"Delux.Pattern.html#t:t/0","title":"Delux.Pattern.t/0","type":"type"},{"doc":"Create LED patterns See https://elixir.bootlin.com/linux/latest/source/Documentation/devicetree/bindings/leds/leds-trigger-pattern.txt","ref":"Delux.Program.html","title":"Delux.Program","type":"module"},{"doc":"Adjust the brightness of a pattern This modifies the pattern to optionally dim it by blinking the LED at 50 Hz. It is not an efficient way of dimming LEDs since the blinking is done on the processor by the kernel.","ref":"Delux.Program.html#adjust_brightness_pwm/2","title":"Delux.Program.adjust_brightness_pwm/2","type":"function"},{"doc":"Return a description with nice ANSI colors The description is returned as IO.ANSI.ansidata() . Use IO.ANSI.format/1 to expect escape codes for display with IO.puts/1 .","ref":"Delux.Program.html#ansi_description/1","title":"Delux.Program.ansi_description/1","type":"function"},{"doc":"Reduce the number of transitions in a pattern This reduces the length of the pattern and in some cases makes it use less of the CPU to run. It's useful for programmatically generated patterns that can take inputs that generate lots of repeating sequences.","ref":"Delux.Program.html#simplify/1","title":"Delux.Program.simplify/1","type":"function"},{"doc":"Return an unformatted description of the pattern See ansi_description/1 for colorized description","ref":"Delux.Program.html#text_description/1","title":"Delux.Program.text_description/1","type":"function"},{"doc":"Program playback mode The playback mode determines what happens when the program gets interrupted or ends. :simple_loop - keep repeating the program. If it's interrupted, just restart at the the beginning. :one_shot - run the program once","ref":"Delux.Program.html#t:mode/0","title":"Delux.Program.mode/0","type":"type"},{"doc":"Program information for one indicator","ref":"Delux.Program.html#t:t/0","title":"Delux.Program.t/0","type":"type"},{"doc":"Utilities for RGB tuples","ref":"Delux.RGB.html","title":"Delux.RGB","type":"module"},{"doc":"Create a new RGB tuple You can pass in a tuple or a color name.","ref":"Delux.RGB.html#new/1","title":"Delux.RGB.new/1","type":"function"},{"doc":"Convert a color to a human-readable ansidata iex&gt; RGB . to_ansidata ( :red , &quot;This is &quot; ) [ :red , &quot;This is &quot; , &quot;red&quot; ] iex&gt; RGB . to_ansidata ( { 0 , 0.5 , 1 } , &quot;This is &quot; ) [ &quot;This is &quot; , &quot;{0, 0.5, 1}&quot; ]","ref":"Delux.RGB.html#to_ansidata/2","title":"Delux.RGB.to_ansidata/2","type":"function"},{"doc":"","ref":"Delux.RGB.html#t:color/0","title":"Delux.RGB.color/0","type":"type"},{"doc":"Colors components go from 0 (off) to 1 (brightest)","ref":"Delux.RGB.html#t:component/0","title":"Delux.RGB.component/0","type":"type"},{"doc":"An RGB triplet Note that accuracy of the color depends on the LEDs in use. The color should be recognizable, but Delux doesn't support calibration.","ref":"Delux.RGB.html#t:t/0","title":"Delux.RGB.t/0","type":"type"},{"doc":"de lux | Latin (roughly) for &quot;of the light&quot; Use LEDs for your user interface delux simplifies creating and running LED blink patterns for use as part of a user interface for an embedded hardware. This library provides: Low overhead LED control via Linux's Sysclass interface - blink sequences get compiled down so that they can be run inside the Linux kernel. Built-in LED effects for common use cases like blinking, cycling LED colors, etc. Prioritization of LED effects Support for many physical LED configurations Nice textual descriptions of what the LED is doing to support remote debug This library is primarily intended for devices with 1 to 10 LEDs. It's currently not for Neopixels and other &quot;smart&quot; LEDs that are more typically found in larger numbers, but could be used for a similar purpose. Before diving in, some terminology is needed: LED - one light emitting element. This doesn't have to be an LED, but the Linux kernel must think that it is and show a directory for it under /sys/class/leds/ . Indicator - a group of 1, 2, or 3 LEDs that a user would perceive as one. This could be a lone green LED, or a red, green and blue LED in one package, or any combination. Program - a one-time or repeating set of instructions for controlling an indicator. Pattern - a low-level sequence of brightness and duration tuples for controlling one LED Slot - a holder for a program. Slots are ordered so a program put in a higher priority slot will take precedence over one in a lower priority slot. For example, if there's a UI feedback slot and a network status slot, programs running in the UI feedback slot could take precedence. To give a flavor of how delux works, here's an example that configures delux with one green LED and then blinks it at 2 Hz: iex&gt; Delux . start_link ( indicators : %{ default : %{ green : &quot;led0&quot; } } ) iex&gt; Delux . render ( Delux.Effects . blink ( :green , 2 ) ) iex&gt; Delux . info ( ) green at 2 Hz This starts Delux with one indicator, :default , that has a green LED known to Linux as &quot;led0&quot; . The Delux.Effects.blink/2 function creates a 2 Hz blinking program for Delux to render. With nothing else specified, Delux.render/1 runs the program on the default indicator in the default slot.","ref":"readme.html","title":"💡 delux 💡","type":"extras"},{"doc":"delux comes with helper functions for creating LED programs. It's also possible to create your own. Here are the built-in ones: Function Description Delux.Effects.off/0 Turn an indicator off Delux.Effects.on/2 Set the indicator to the specified color (within reason, that is. You can't make a green LED red, for example.) Delux.Effects.blink/3 Blink a color on and off at a fixed rate Delux.Effects.number_blink/3 Blink the indicator the specified number of times Delux.Effects.blip/3 Show two colors quickly in succession. E.g., use to show feedback from pressing a button. Delux.Effects.cycle/3 Cycle through a set of colors at a fixed rate Delux.Effects.waveform/2 Synthesize an LED pattern from a function Delux.Morse.encode/3 Send a string in Morse code","ref":"readme.html#built-in-indicator-programs","title":"💡 delux 💡 - Built-in indicator programs","type":"extras"},{"doc":"It's worthwhile thinking about how you want your device's LEDs to behave before writing any code. The first step is to figure out what LEDs are available and how to group them into indicators. To see what's available, list the directories in /sys/class/leds . If something is missing, you'll likely need to adjust the device tree configuration and make it appear. That's discussed somewhat below, but this is device-specific, so you'll need to look elsewhere for precise guides. After you've found the LEDs, group them and give them indicator names. If you just have one indicator, call it :default . That will make delux 's API more convenient. Step 2 is to decide what slots make sense for your application. Only one program per indicator can be run at a time. Every time that you set a program on an indicator, it replaces any running programs for that indicator in that slot. The default list of slots probably suffice to start: :status - The lowest priority slot. This is for general device status like whether networking is working and if the device is initializing and connected to the back end. :notification - This is a medium priority slot. Use it to show transient things like an alert that requires operator attention to clear. :user_feedback - This is the highest priority slot and for showing feedback to a user. For example, it could blink the LED when user pushes a button so they know that the device is doing something. Clearing the program in a slot makes delux render the program on the next lower priority slot or if there's no program, then the indicator is turned off. Tip If you find yourself creating state machines in your code to control the indicators, try adding one or more slots as an alternative. Once you feel good about the indicators and slots, it's time to configure delux .","ref":"readme.html#before-you-use-delux","title":"💡 delux 💡 - Before you use delux","type":"extras"},{"doc":"After adding delux to your mix dependencies, add Delux to a supervision tree of your choice. The childspec looks like: { Delux , name : MyIndicators , indicators : %{ default : %{ red : &quot;led0:red&quot; , green : &quot;led0:green&quot; , blue : &quot;led0:blue&quot; } , indicator2 : %{ red : &quot;led1&quot; } } } The above configuration shows two indicators. The first is called :default and is an RGB indicator. The second is a lone red LED that's used as :indicator2 . As mentioned before, if you only have one indicator, call it :default . Other options include setting the list of slots and giving the Delux GenServer a name. If you don't give the Delux GenServer a name, it will register itself as a singleton and you won't have to pass the server name or pid to any of the API calls.","ref":"readme.html#configuration","title":"💡 delux 💡 - Configuration","type":"extras"},{"doc":"For sake of example, lets start the Delux GenServer the manual way by calling start_link/1 directly. The usual way in your programs would be to add the childspec to the supervision tree as shown earlier. Modify the LED names to whatever you have. iex&gt; Delux . start_link ( indicators : %{ default : %{ red : &quot;led0:red&quot; , green : &quot;led0:green&quot; , blue : &quot;led0:blue&quot; } , indicator2 : %{ red : &quot;led1&quot; } } ) After you have a Delux GenServer and running, call Delux.render/1 to turn on the default indicator in the default slot: iex&gt; Delux . render ( Delux.Effects . on ( :white ) ) :ok Even if you don't have an RGB indicator, passing :white should turn on all of the LEDs that you do have. If you have two indicators and want them to blink back and forth, you can try this: iex&gt; Delux . render ( %{ default : Delux.Effects . cycle ( [ :black , :white ] , 1 ) , indicator2 : Delux.Effects . cycle ( [ :white , :black ] , 1 ) } ) :ok Finally, pass a second parameter to Delux.render/2 to assign the programs to another slot.","ref":"readme.html#use","title":"💡 delux 💡 - Use","type":"extras"},{"doc":"Indicator programs are a collection of LED patterns and metadata as defined by the Delux.Program struct. The helper functions in Delux.Effects and Delux.Morse create these and can be used as examples. The core of the program is an Delux.Pattern . There are three patterns per program for each of the color channels. Each pattern is a list of {value, duration} tuples where value is a number from 0 to 1 and duration is an integer number of milliseconds. While delux internally holds a number from 0 (off) to 1 (full on) for the LED's value at that point in time, this gets scaled to an integer when sent to Linux. This integer depends on the maximum brightness value for an LED. This is often just 1 since Linux can only turn the LED off and on. Sometimes Linux can set the LED to multiple levels and in those cases, the maximum value will be greater than 1 (often 255). You don't need to worry about scaling other than to be aware that fractional values will be rounded when sent to Linux and this will mess up colors. Linux interpolates the LED value over the duration between pairs of tuples. A common idiom is to have 0 duration tuples to turn off interpolation. For example, [{1, 100}, {1, 0}, {0, 100}, {0, 0}] turns the LED on for 100 ms and then off for 100 ms without any interpolation. See Linux's LED pattern trigger documentation at leds-trigger-pattern.txt for more info.","ref":"readme.html#creating-your-own-programs","title":"💡 delux 💡 - Creating your own programs","type":"extras"},{"doc":"The Linux kernel's HZ configuration sets the granularity at which Delux can render patterns. For example, if HZ=100 , the timing resolution is 10 ms. The kernel also adds a start delay for any pattern. Delux can compensate for both effects to more accurately render programs. This is ultimately limited to the timer resolution so if the system only supports 10 ms resolution, that's the best that Delux can do. Delux can't automatically detect the HZ setting so it must be told via the :backend options: Delux . start_link ( backend : [ hz : 100 ] , indicators : %{ default : %{ green : &quot;led0&quot; } } ) If you need better resolution, you'l need to update the Linux kernel configuration with CONFIG_HZ=1000 and rebuild. Be sure to update the :hz value passed to Delux so that the compensation is calculated correctly. To verify timing, connect a logic analyzer to an LED controlled by Delux and run this: Delux . render ( Delux.Effects . timing_test ( :on ) ) See Delux.Effects.timing_test/2 for details on what you should see.","ref":"readme.html#timing-precision","title":"💡 delux 💡 - Timing precision","type":"extras"},{"doc":"delux works in all official Nerves systems. If not using Nerves, you will need to have CONFIG_LEDS_TRIGGER_PATTERN=y enabled your Linux kernel configuration. The second step to using Linux's LED subsystem is to configure LEDs in the device tree. You can't just use an arbitrary GPIO to turn on the LED like you can with Circuits.GPIO . Linux needs to know about the GPIO. It's also possible to hook up PWMs and LED drivers. See the LED drivers for options. Tip If you're using a BeagleBone, check out Udo Schneider's blog post on device tree overlays The following is an example device tree configuration for telling Linux about GPIO-connected LEDs. It is platform-specific so you can't just copy/paste it. It sets up two RGB LEDs and makes one blink early in the boot process. / { leds { pinctrl-names = &quot;default&quot;; pinctrl-0 = &lt;&amp;pinctrl_leds&gt;; compatible = &quot;gpio-leds&quot;; led1_red { label = &quot;led1:red&quot;; gpios = &lt;&amp;pio 0 7 GPIO_ACTIVE_LOW&gt;; }; led1_green { label = &quot;led1:green&quot;; gpios = &lt;&amp;pio 4 15 GPIO_ACTIVE_LOW&gt;; }; led1_blue { label = &quot;led1:blue&quot;; gpios = &lt;&amp;pio 4 4 GPIO_ACTIVE_LOW&gt;; /* Blink LED at 2 Hz (250 ms on, off) */ linux,default-trigger = &quot;timer&quot;; default-state = &quot;on&quot;; led-pattern = &lt;250 250&gt;; }; led2_red { label = &quot;led2:red&quot;; gpios = &lt;&amp;pio 4 5 GPIO_ACTIVE_LOW&gt;; }; led2_green { label = &quot;led2:green&quot;; gpios = &lt;&amp;pio 4 14 GPIO_ACTIVE_LOW&gt;; }; led2_blue { label = &quot;led2:blue&quot;; gpios = &lt;&amp;pio 4 7 GPIO_ACTIVE_LOW&gt;; }; }; };","ref":"readme.html#linux-kernel-configuration","title":"💡 delux 💡 - Linux kernel configuration","type":"extras"},{"doc":"Copyright (C) 2022 SmartRent Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at [http://www.apache.org/licenses/LICENSE-2.0](http://www.apache.org/licenses/LICENSE-2.0) Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"💡 delux 💡 - License","type":"extras"},{"doc":"","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is a big update that improves program playback timing to compensate for the Linux kernel's HZ configuration and implementation of LED pattern triggers. This affects all programs, but you probably won't notice it unless you're creating Morse code patterns or measuring LED output with a logic analyzer. Backwards incompatible changes &quot;Priority&quot; is now called &quot;slot&quot;. If you have custom priorities defined in your configurations, you will need to change them to slot . This change was made to make the use of this feature easier to explain. I.e. programs are put in slots, one program per slot per indicator, slots have an order. Changes Added :backend parameters and specifically the :hz parameter to support better playback timing. If unset, HZ=1000 is assumed. This results in almost the same timings as earlier versions. See the README for more information. Added Delux.Effects.number_blink/3 for blinking out a number. This is for things like error codes - like error 1, 2, 3, etc. Added Delux.Effects.timing_test/2 to debug timing precision issues with a logic analyzer. Removed unnecessary writes to the filesystem when using multiple indicators. This fixes an issue where a change on one indicator restarts a program on a second indicator. Reorganized the backend code to support future alternative backends. This is currently unplanned work, but it's now easier to think about adding a way to run Delux using Circuits.GPIO or a simulated LED.","ref":"changelog.html#v0-4-0-2022-10-14","title":"Changelog - v0.4.0 - 2022-10-14","type":"extras"},{"doc":"Changes Support dimming arbitrary patterns to off. The dimming feature still doesn't dim all patterns, but dimming to off works for everything now.","ref":"changelog.html#v0-3-1-2022-09-26","title":"Changelog - v0.3.1 - 2022-09-26","type":"extras"},{"doc":"Changes Favor singleton use of Delux with default arguments to render/3 and info/2 . Now that Delux is being used more frequently as a singleton, this makes the API more convenient. This is backwards incompatible if you had been taking advantage of default arguments, but you should get compile-time and dialyzer errors. If you do name your Delux GenServers, you'll have to specify all arguments to render/3 and info/2 . Improve argument error messages by reporting what the valid options are in addition to what you passed.","ref":"changelog.html#v0-3-0-2022-09-07","title":"Changelog - v0.3.0 - 2022-09-07","type":"extras"},{"doc":"Changes Register the Delux GenServer with a default name so that pids or names don't need to be passed to all APIs. Since Delux is almost always used as a singleton, this simplifies the API.","ref":"changelog.html#v0-2-0-2022-08-26","title":"Changelog - v0.2.0 - 2022-08-26","type":"extras"},{"doc":"Changes Fix typespecs to remove warnings found by Dialyzer Update Delux.Effects.waveform/3 to support color atom names and check RGB tuples for range. The latter fixes errors that get detected later on and are more confusing to figure out.","ref":"changelog.html#v0-1-3-2022-08-11","title":"Changelog - v0.1.3 - 2022-08-11","type":"extras"},{"doc":"Changes Improve Delux.Effects.waveform/3 so that it's easier to use and produces shorter patterns. It now has examples in the docs and unit tests.","ref":"changelog.html#v0-1-2-2022-08-11","title":"Changelog - v0.1.2 - 2022-08-11","type":"extras"},{"doc":"Changes Adjust timed pattern playback to minimize trimming LED programs. Unfortunately, LED programs still get cut off at the end with this release. If you're using Morse code, you'll see this. We plan on fixing this completely in a future release. Support empty LED setups to simplify configuration of multi-target projects and unit tests.","ref":"changelog.html#v0-1-1-2022-08-10","title":"Changelog - v0.1.1 - 2022-08-10","type":"extras"},{"doc":"Initial release","ref":"changelog.html#v0-1-0-2022-08-08","title":"Changelog - v0.1.0 - 2022-08-08","type":"extras"}]